#include <libc.h>
#include <fstream.h>
#include "filter.h"

/*
 * Print the 1-norm of the error transfer functions of a DSM
 */

main(int argc, char *argv[]){
    if( argc < 2 ){
	cerr << "File containing Z-transform needed.\n";
	exit(-1);
	}
    ratfn H;
    if( !H.read_in( *++argv ) ) exit(-1);

    double kmin=0.1, kmax=10, kfactor;
    if( argc > 2 )
	kmin = atof(*++argv);
    if( argc > 2 )
	kmax = atof(*++argv);
    kfactor = pow(kmax/kmin, .05 );


    for(double k=kmin; k<(1+1e-10)*kmax; k*= kfactor){
	ratfn Hk=H.num/(((complex)k)*H.den+((complex)(1-k))*H.num);
	if( Hk.stable()==0 ){
	    cout << "k = "<<k<<", unstable.\n";
	    continue;
	    }
	cxfilter filter(Hk);
	double h1 = abs( filter.simulate(1) );
	for(int n=1; n<1000; ++n)
	    h1 += abs( filter.simulate(0) );
	cout << "k="<<k<<", ||h'||_1= " << h1 <<", H'="<< Hk << endl;
	}
    }
